/* ===========================

File: InitTheMenus
Function: Pull in menu lists from a resource file.
History: 4/27/89 Original by Prototyper.

============================== */

/* *********************************** */
/* These are the other includes for general routines */

#include <Strings.h>
#include <IM1_5Protos.h>

extern char *strcpy (Str255 *, char *);	/* LSC string prototype */

/* *********************************** */

#define      TRUE   1
#define      FALSE  0
#define      NIL    0

/* *********************************** */

MenuHandle AppleMenu;		/* Apple menu list */
MenuHandle FileMenu;
MenuHandle EditMenu;
MenuHandle ModeMenu;

void InitMyMenus (void);	/* Prototype for init menus */


void InitMyMenus ()			/* Initialize menus */
{

	/* Menu resource ID for       */
#define Menu_1 1001
	/* Menu resource ID for   File    */
#define Menu_2 1002
	/* Menu resource ID for   Edit    */
#define Menu_3 1003
	/* Menu resource ID for   Mode    */
#define Menu_4 1004

	MenuHandle tempMenu;	/* Scratch handle */

	ClearMenuBar ();		/* Clear any old menu bars */

	/* Apple menu */
	tempMenu = GetMenu (Menu_1);	/* Get the menu resource*/
	InsertMenu (tempMenu, 0);	/* Insert into menu bar */
	AddResMenu (tempMenu, 'DRVR');	/* Add in DAs */
	AppleMenu = tempMenu;	/* Save for later use */

	/* This menu is    File  */
	tempMenu = GetMenu (Menu_2);	/* Get the menu resource*/
	InsertMenu (tempMenu, 0);	/* Insert into menu bar */
	FileMenu = tempMenu;	/* Save for later use */

	/* This menu is    Edit  */
	tempMenu = GetMenu (Menu_3);	/* Get the menu resource*/
	InsertMenu (tempMenu, 0);	/* Insert into menu bar */
	EditMenu = tempMenu;	/* Save for later use */

	/* This menu is    Mode  */
	tempMenu = GetMenu (Menu_4);	/* Get the menu resource*/
	InsertMenu (tempMenu, 0);	/* Insert into menu bar */
	ModeMenu = tempMenu;	/* Save for later use */

	DrawMenuBar ();			/* Draw the menu bar */

}

