/*
	pix_io.h

	file input and output of PICTs and cut and paste with CLIPBOARD
	and most important - conversion from std picts to the proper colors
	for PROTON, FLOURINE, and the mixture of the two

*/

#include "initclut.h"

short GetPic( SFReply theReply,  PicHandle *source );
/* reads PICT file and stores in the the handle */

void PutPic( SFReply theReply, PicHandle result_pic, PaletteHandle thePalette );
/* write the Pixel image into a PICT file that uses thePalette */

CGrafPtr pic_to_bmap( PicHandle picH, Rect * frame, GDHandle themaxdevice );
/* create a an offscreen port-pix-map and fill it with the picture */

void add_bmaps( CGrafPtr proton_bmap, Rect *proton_rect, short pr_off_top, short pr_off_left,
				CGrafPtr flourine_bmap, Rect *flourine_rect, short fl_off_top, short fl_off_left,
				CGrafPtr *result_bmap, Rect *result_rect, GDHandle themaxdevice );
